'###################################################################################################################
'#                                                                                                                 #
'#                                                                                                                 #
'# Version 0.2 _ CAN aufsetzen, 8 Kanle anzeigen                                                                  #
'#                                                                                                                 #
'# Beta 0.1 _ Erste Verion                                                                                         #
'# Beta 0.2 _ Bildschirmfrequenz herabgesetzt dafr Bildschirmlschen eingebaut                                    #
'#                                                                                                                 #
'###################################################################################################################

'Parameter fr den Compiler

$regfile = "m128can.dat"                                    ' Prozessor AT90CAN128
$crystal = 16000000                                         ' Quarz-Frequenz = 16,000 MHz
$baud = 9600                                                ' Baudrate UART0 _ Anschluss ISP_Pin9=TX/PIN1=RX
$baud1 = 9600                                               ' Baudrate UART1 _ Intern auf Speakjet-IC (OPTION)
$hwstack = 150
$swstack = 128
$framesize = 120

$lib "glcdeadogm128x6.lbx"                                  'Library fr das DOGM128-Display

'CONFIG SINGLE = Scientific , DIGITS = 2                    'immer nur 2 Nachkommerstellen anzeigen



'________________________________________________
Config Portc.4 = Output : Portc.4 = 1                       'DOGM_CS1
Config Portc.2 = Output : Portc.2 = 1                       'DOGM_A0
Config Portc.1 = Output : Portc.1 = 1                       'DOGM_SCLK
Config Portc.3 = Output : Portc.3 = 1                       'DOGM_SI
Config Portc.0 = Output : Portc.0 = 1                       'DOGM_Reset
'-----------------------------------------------------------------------


' Digitale Eingnge_____________________________________________________




Config Portb.7 = Output : Portb.7 = 0                       'Backlight
Backlgt Alias Portb.7


Config Graphlcd = 128 * 64eadogm , Cs1 = Portc.4 , A0 = Portc.2 , Si = Portc.3 , Sclk = Portc.1 , Rst = Portc.0

Declare Sub Can_init()                                      ' init
Declare Sub Can_rx()                                        ' poll to receive data


Dim Can_rx_data(8) As Byte                                  ' contains received data
Dim Can_rx_dlc As Byte                                      ' length of datafield
Dim Data_count As Byte
Dim Mob_count As Byte
Dim Mob As Byte
Dim Received As Byte
Dim Kanal_32 As Long

Dim Display_count As Word

Dim CAN_id(8) As Word
Dim Msg_startbyte(8) As  Byte
Dim Msg_stopbyte(8) As  Byte
Dim calc_factor(8) As Single
Dim calc_offset(8) As Single
Dim Kanal(8) As Single


'*******************************************************************************
'*
'*   Minimal Initialisierung, Bildschirm und CAN
'*
'*******************************************************************************


'*** old: "start once", now in initialisation

'            Portc.4 = 1                                        'DOGM_CS1
'            Portc.2 = 1                                        'DOGM_A0
'            Portc.1 = 1                                        'DOGM_SCLK
'            Portc.3 = 1                                        'DOGM_SI
'            Portc.0 = 1                                        'DOGM_Reset
            Initlcd
            Waitms 50
            Glcdcmd &B10000001
            Glcdcmd 23                                   '39 / 0 -63 Kontrast
            Glcdcmd &B10100110
            Waitms 50
            Set Backlgt
            Setfont Font8x8TT
            Cls

'CAN Table einhngen
$include "CAN_Matrix_ZOE.bas"

Enable Interrupts

Call Can_init()



'###################################################################################################
'####################################### HAUPTSCHLEIFE #############################################

Do

   Reset Watchdog
   Incr Display_count

   Call Can_rx()

   If Display_count > 5000  Then    'alle 50 Aufrufe (Displayrefresh)
      Display_count = 0

      Gosub Screen1

   End If
Loop

End

'##      ENDE HAUPTSCHLEIFE    #####################################################################
'###################################################################################################


Sub Can_init()

  Cangie = &H00                  ' Cangie = &HFE (0=kein Interrupt)                                             ' disable interrupt
  Canie1 = &H00                  ' Canie1 = &H7F (0=kein Interrupt)                                            ' disable interrupt
  Canie2 = &H00                  ' Canie2 = &HFF (0=kein Interrupt)                                            ' disable interrupt
  Canbt1 = &H02                  ' Geschwindigkeit CAN-BUS = 500 KBit/s
  Canbt2 = &H0C                  ' Bitrate-Einstellung fr Quarz 16 MHz
  Canbt3 = &H37                  ' Bitrate-Einstellung fr Quarz 16 MHz
  Cangcon = &H02                 ' CAN-Kanal einschalten

'Can_rx_mob:
  For Mob_count = 1 To 8
    Mob = Mob_count - 1
    Shift Mob , Left , 4
    Canpage = Mob                                             ' select MOb
    Canstmob = 0                                              ' clear  status register
    Cancdmob = &HC0
    Canidt4 = 0                                               ' set ID register
    Canidt3 = 0
    Canidt2 = low(CAN_id(Mob_count))
    Canidt1 = high(CAN_id(Mob_count))
    Canidm4 = 0                                               ' set mask register
    Canidm3 = 0
    Canidm2 = &HFF
    Canidm1 = &HFF
  next
End Sub

'___________________________________________________________________________________________________

Sub Can_rx()

  For Mob_count = 1 To 8
    Mob = Mob_count - 1
    Shift Mob , Left , 4
    Canpage = Mob                                            ' select MOb
    If Canstmob.5 = 1 Then                                      ' bit 5 = RXOK
      Can_rx_dlc = Cancdmob And &H0F                        ' get length of datafield, DLC 0-3
      For Data_count = 1 To Can_rx_dlc
        Can_rx_data(data_count) = Canmsg                    ' get data
      Next
      Canstmob = &H00                                       ' reset status register
      Cancdmob = &HC0                                       ' restart MOb
      Kanal_32 = 0
      For Data_count = Msg_startbyte(Mob_count) to Msg_stopbyte(Mob_count)
        shift Kanal_32 , left , 8
        Kanal_32= Kanal_32+Can_rx_data(data_count)
      Next

      Kanal(Mob_count)=Kanal_32*calc_factor(Mob_count)
      Kanal(Mob_count)=Kanal(Mob_count)+calc_offset(Mob_count)
    End If
  Next

End Sub



'###########################__SCREEN 1__SCREEN 1__SCREEN 1__SCREEN 1__SCREEN 1__SCREEN 1__SCREEN 1__SCREEN 1  __SCREEN 1__SCREEN 1  __SCREEN 1__SCREEN 1

Screen1:

'   Setfont Font8x8
   CLS
   Lcdat 1 , 3 , "1: "; Kanal(1);
   Lcdat 2 , 1 , "2: "; Kanal(2);
   Lcdat 3 , 1 , "3: "; Kanal(3);
   Lcdat 4 , 1 , "4: "; Kanal(4);
   Lcdat 5 , 1 , "5: "; Kanal(5);
   Lcdat 6 , 1 , "6: "; Kanal(6);
   Lcdat 7 , 1 , "7: "; Kanal(7);
   Lcdat 8 , 1 , "8: "; Kanal(8);

Return


'Grafik fr das GLCD hinzufgen_____________________ muss am Ende stehen.......

'Gstart:
'$bgf "zoe_logo_inv.bgf"


'Fonts fr das GLCD hinzufgen______________________ muss am Ende stehen.......
$include "number8x8TT.font"