'*******************************************************************************
'*
'* CAN Matrix fr ZOE Fahrzeug-CAN
'*
'* Usage:
'*
'*
'* CAN_id:        der CAN Kanal in dem die Botschaft enthalten ist [&H1...&H7FF]
'* Startbyte:     das niedrigste Byte bei dem die Botschaft beginnt [1...8]
'* Msg_stopbyte:  das hchste Byte bei dem die Botschaft endet  [1...8]
'* mul/div:       1... Multipilkation  2...Division
'* Faktor:        mit dieser Zahl wird die Botschaft zuerst Multipliziert oder Divitiert
'* Offset:        Diese Zahl wird bei der Umrechnung dazugezhlt (nach der Multiplikation)
'*
'* Alle Zahlen sind vom Type WORD, maximal daher 0 .. 65565
'* Um die Lnge "Word" (2 Byte) zu definieren muss ein % am Ende jeder Zahl stehen.
'*
'*******************************************************************************



CAN_id(1) = &H20*       &H5D7       'Wert / 100= km/h real ohne Tachokorrektur
Msg_startbyte(1) =1+    0           'Start Byte
Msg_stopbyte(1)  =1+    1           'Stop Byte
calc_factor(1) =        0.01        'Umrechnungsfaktor
calc_offset(1) =        0.0         'Umrechnungsoffset

CAN_id(2) = &H20*       &H4F8       'Wert / 100 = km/h mit Tachokorrektur
Msg_startbyte(2) =1+    3
Msg_stopbyte(2)  =1+    4
calc_factor(2) =        0.01
calc_offset(2) =        0.0

CAN_id(3) = &H20*       &H42E       'SOC ?
Msg_startbyte(3) =1+    0
Msg_stopbyte(3)  =1+    1
calc_factor(3) =        0.0025
calc_offset(3) =        0.0

CAN_id(4) = &H20*       &H1FD       'Im Display angezeigte Leistung in kW
Msg_startbyte(4) =1+    6
Msg_stopbyte(4)  =1+    6
calc_factor(4) =        1.0
calc_offset(4) =        -80.0

CAN_id(5) = &H20*       &H439       'Momentane Leistung kW incl. Rekuperation ohne Klimaanlage
Msg_startbyte(5) =1+    0
Msg_stopbyte(5)  =1+    1
calc_factor(5) =        0.005
calc_offset(5) =        -80.0

CAN_id(6) = &H20*       &H12E        'Lenkwinkel
Msg_startbyte(6) =1+    3
Msg_stopbyte(6)  =1+    3
calc_factor(6) =        1.0
calc_offset(6) =        -127.0

CAN_id(7) = &H20*       &H29C        'Vorderrad links  ESP/ABS Trigger  ??
Msg_startbyte(7) =1+    0
Msg_stopbyte(7)  =1+    1
calc_factor(7) =        1.0
calc_offset(7) =        0.0

CAN_id(8) = &H20*       &H3F7       'Gangwahl
Msg_startbyte(8) =1+    0
Msg_stopbyte(8)  =1+    1
calc_factor(8) =        1.0
calc_offset(8) =        0.0

